Shacal2Engine (Bouncy Castle Library 1.54 API Specification)
Date: 2015-12-29

org.bouncycastle.crypto.engines

## Class Shacal2Engine

- java.lang.Object
- - org.bouncycastle.crypto.engines.Shacal2Engine

- All Implemented Interfaces:
    BlockCipher

      public class Shacal2Engine
      extends java.lang.Object
      implements BlockCipher

  Block cipher Shacal2, designed by Helena Handschuh and David Naccache, based on hash function SHA-256, using SHA-256-Initialization-Values as data and SHA-256-Data as key.

  A description of Shacal can be found at: http://citeseerx.ist.psu.edu/viewdoc/summary?doi=10.1.1.3.4066 Best known cryptanalytic (Wikipedia 11.2013): Related-key rectangle attack on 44-rounds (Jiqiang Lu, Jongsung Kim). Comments are related to SHA-256-Naming as described in FIPS PUB 180-2

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `Shacal2Engine()`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `java.lang.String` | `getAlgorithmName()` Return the name of the algorithm the cipher implements.
    `int` | `getBlockSize()` Return the block size for this cipher (in bytes).
    `void` | `init(boolean _forEncryption, CipherParameters params)` Initialise the cipher.
    `int` | `processBlock(byte[] in, int inOffset, byte[] out, int outOffset)` Process one block of input from the array in and write it to the out array.
    `void` | `reset()` Reset the cipher.
    `void` | `setKey(byte[] kb)`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### Shacal2Engine

          public Shacal2Engine()

  - ### Method Detail

    - #### reset

          public void reset()

      Description copied from interface: `BlockCipher`
      Reset the cipher. After resetting the cipher is in the same state as it was after the last init (if there was one).
      Specified by:
        `reset` in interface `BlockCipher`

    - #### getAlgorithmName

          public java.lang.String getAlgorithmName()

      Description copied from interface: `BlockCipher`
      Return the name of the algorithm the cipher implements.
      Specified by:
        `getAlgorithmName` in interface `BlockCipher`
      Returns:
        the name of the algorithm the cipher implements.

    - #### getBlockSize

          public int getBlockSize()

      Description copied from interface: `BlockCipher`
      Return the block size for this cipher (in bytes).
      Specified by:
        `getBlockSize` in interface `BlockCipher`
      Returns:
        the block size for this cipher in bytes.

    - #### init

          public void init(boolean _forEncryption,
                  CipherParameters params)
                    throws java.lang.IllegalArgumentException

      Description copied from interface: `BlockCipher`
      Initialise the cipher.
      Specified by:
        `init` in interface `BlockCipher`
      Parameters:
        `_forEncryption` - if true the cipher is initialised for encryption, if false for decryption.
        `params` - the key and other data required by the cipher.
      Throws:
        `java.lang.IllegalArgumentException` - if the params argument is inappropriate.

    - #### setKey

          public void setKey(byte[] kb)

    - #### processBlock

          public int processBlock(byte[] in,
                         int inOffset,
                         byte[] out,
                         int outOffset)
                           throws DataLengthException,
                                  java.lang.IllegalStateException

      Description copied from interface: `BlockCipher`
      Process one block of input from the array in and write it to the out array.
      Specified by:
        `processBlock` in interface `BlockCipher`
      Parameters:
        `in` - the array containing the input data.
        `inOffset` - offset into the in array the data starts at.
        `out` - the array the output data will be copied into.
        `outOffset` - the offset into the out array the output will start at.
      Returns:
        the number of bytes processed and produced.
      Throws:
        `DataLengthException` - if there isn't enough data in in, or space in out.
        `java.lang.IllegalStateException` - if the cipher isn't initialised.